<!-- Label for toolbox; draggable to edit area to add corresponding element -->
<template>
  <div class="label" draggable="true"
   v-on:dragstart="dragstart($event)"
   v-on:dragend="dragend($event)"
   v-on:dragenter="dragenter($event)"
   >
    {{ label }}
  </div>
</template>

<script lang="ts">
import Vue from 'vue';
import { viewData } from '../ViewData';

export default Vue.extend({
  props: {
    label: {
      type: String,
      required: true
    }, 
    objectType: {
      type: String,
      required: true
    } 
  },

  data () {
    return {
    }
  },

  methods: {
    dragstart: function (e): void {
      //console.log('start drag!');
      e.target.style.opacity = 0.5;
      e.dataTransfer.setData('text/plain', 'dummy'); // Firefox http://stackoverflow.com/questions/21507189/dragenter-dragover-and-drop-events-not-working-in-firefox
    },
    dragend: function (e): void {
      //console.log(e);
      //console.log(`drop to ${e.screenX},${e.screenY} in draw area`);      
      e.target.style.opacity = 1;
      viewData.createAt(this.objectType, e.screenX, e.screenY);
    },
    dragenter: function (e): void {
      //console.log('drag enter!');
    }
  },

  mounted () {
    //console.log('Label mounted');
  },
});

</script>

<style scoped>
.label {
  background-color: #666666;
  color: white;
  border: 1px solid black;
  margin: 8px;
  padding: 4px;
  padding-left: 10px;
  padding-right: 10px;
  display: inline-block;
}
</style>
